# LabelledArrays.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/LabelledArrays/stable/)

[![codecov](https://codecov.io/gh/SciML/LabelledArrays.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/LabelledArrays.jl)
[![Build Status](https://github.com/SciML/LabelledArrays.jl/workflows/CI/badge.svg)](https://github.com/SciML/LabelledArrays.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

# About

LabelledArrays.jl is a package which provides arrays with labels, i.e. they are
arrays which `map`, `broadcast`, and all of that good stuff, but their components
are labelled. Thus for instance you can set that the second component is named
`:second` and retrieve it with `A.second`.

## How to install

The package can be installed from this repository by

```julia
using Pkg
Pkg.add("LabelledArrays")
```

## Tutorials and Documentation

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/LabelledArrays/stable/). Use the
[in-development documentation](https://docs.sciml.ai/LabelledArrays/dev/) for the version of
the documentation, which contains the unreleased features.

## SLArrays

The `SLArray` and `SLVector` macros are for creating static LabelledArrays.
First you create the type and then you can use that constructor to generate
instances of the labelled array.

```julia
ABC = @SLVector (:a, :b, :c)
A = ABC(1, 2, 3)
A.a == 1

ABCD = @SLArray (2, 2) (:a, :b, :c, :d)
B = ABCD(1, 2, 3, 4)
B.c == 3
B[2, 2] == B.d
```

Here we have that `A == [1,2,3]` and for example `A.b == 2`. We can create a
typed `SLArray` via:

```julia
SVType = @SLVector Float64 (:a, :b, :c)
```

Alternatively, you can also construct a static labelled array using the
`SLVector` constructor by writing out the entries as keyword arguments:

```julia
julia> SLVector(a = 1, b = 2, c = 3)
3-element SLArray{Tuple{3},1,(:a, :b, :c),Int64}:
 1
 2
 3
```

For general N-dimensional labelled arrays, you need to specify the size
(`Tuple{dim1,dim2,...}`) as the type parameter to the `SLArray` constructor:

```julia
julia> SLArray{Tuple{2, 2}}(a = 1, b = 2, c = 3, d = 4)
2×2 SLArray{Tuple{2,2},2,(:a, :b, :c, :d),Int64}:
 1  3
 2  4
```

Constructing copies with some items changed is supported by
a keyword constructor whose first argument is the source and
additional keyword arguments change several entries.

```julia
julia> v1 = SLVector(a = 1.1, b = 2.2, c = 3.3);

julia> v2 = SLVector(v1; b = 20.20, c = 30.30)
3-element SLArray{Tuple{3},Float64,1,3,(:a, :b, :c)}:
  1.1
 20.2
 30.3
```

```julia
julia> ABCD = @SLArray (2, 2) (:a, :b, :c, :d);

julia> B = ABCD(1, 2, 3, 4);

julia> B2 = SLArray(B; c = 30)
2×2 SLArray{Tuple{2,2},Int64,2,4,(:a, :b, :c, :d)}:
 1  30
 2   4
```

One can also specify the indices directly.

```julia
julia> EFG = @SLArray (2, 2) (e = 1:3, f = 4, g = 2:4);

julia> y = EFG(1.0, 2.5, 3.0, 5.0)
2×2 SLArray{Tuple{2,2},Float64,2,4,(e = 1:3, f = 4, g = 2:4)}:
 1.0  3.0
 2.5  5.0

julia> y.g
3-element view(reshape(::StaticArrays.SArray{Tuple{2,2},Float64,2,4}, 4), 2:4) with eltype Float64:
 2.5
 3.0
 5.0

julia> Arr = @SLArray (2, 2) (a = (2, :), b = 3);

julia> z = Arr(1, 2, 3, 4);

julia> z.a
2-element view(::StaticArrays.SArray{Tuple{2,2},Int64,2,4}, 2, :) with eltype Int64:
 2
 4
```

## LArrays

The `LArrays`s are fully mutable arrays with labels. There is no performance
loss by using the labelled instead of indexing. Using the macro with values
and labels generates the labelled array with the given values:

```julia
A = @LArray [1, 2, 3] (:a, :b, :c)
A.a == 1
```

One can generate a labelled array with undefined values by instead giving
the dimensions:

```julia
A = @LArray Float64 (2, 2) (:a, :b, :c, :d)
W = rand(2, 2)
A .= W
A.d == W[2, 2]
```

or using an `@LVector` shorthand:

```julia
A = @LVector Float64 (:a, :b, :c, :d)
A .= rand(4)
```

As with `SLArray`, alternative constructors exist that use the keyword argument
form:

```julia
julia> LVector(a = 1, b = 2, c = 3)
3-element LArray{Int64,1,(:a, :b, :c)}:
 1
 2
 3

julia> LArray((2, 2); a = 1, b = 2, c = 3, d = 4) # need to specify size as first argument
2×2 LArray{Int64,2,(:a, :b, :c, :d)}:
 1  3
 2  4
```

One can also specify the indices directly.

```julia
julia> z = @LArray [1.0, 2.0, 3.0] (a = 1:2, b = 2:3);

julia> z.b
2-element view(::Array{Float64,1}, 2:3) with eltype Float64:
 2.0
 3.0

julia> z = @LArray [1 2; 3 4] (a = (2, :), b = 2:3);

julia> z.a
2-element view(::Array{Int64,2}, 2, :) with eltype Int64:
 3
 4
```

The labels of LArray and SLArray can be accessed
by function `symbols`, which returns a tuple of symbols.

## Example: Nice DiffEq Syntax Without A DSL

LabelledArrays.jl are a way to get DSL-like syntax without a macro. In this case,
we can solve differential equations with labelled components by making use of
labelled arrays, and always refer to the components by name instead of index.

Let's solve the Lorenz equation. Using `@LVector`s, we can do:

```julia
using LabelledArrays, OrdinaryDiffEq

function lorenz_f!(du, u, p, t)
    du.x = p.σ * (u.y - u.x)
    du.y = u.x * (p.ρ - u.z) - u.y
    du.z = u.x * u.y - p.β * u.z
end

u0 = @LArray [1.0, 0.0, 0.0] (:x, :y, :z)
p = @LArray [10.0, 28.0, 8 / 3] (:σ, :ρ, :β)
tspan = (0.0, 10.0)
prob = ODEProblem(lorenz_f!, u0, tspan, p)
sol = solve(prob, Tsit5())
# Now the solution can be indexed as .x/y/z as well!
sol[10].x
```

We can also make use of `@SLVector`:

```julia
LorenzVector = @SLVector (:x, :y, :z)
LorenzParameterVector = @SLVector (:σ, :ρ, :β)

function f(u, p, t)
    x = p.σ * (u.y - u.x)
    y = u.x * (p.ρ - u.z) - u.y
    z = u.x * u.y - p.β * u.z
    LorenzVector(x, y, z)
end

u0 = LorenzVector(1.0, 0.0, 0.0)
p = LorenzParameterVector(10.0, 28.0, 8 / 3)
tspan = (0.0, 10.0)
prob = ODEProblem(f, u0, tspan, p)
sol = solve(prob, Tsit5())
```

## Relation to NamedTuples

Julia's Base has NamedTuples in v0.7+. They are constructed as:

```julia
p = (σ = 10.0, ρ = 28.0, β = 8 / 3)
```

and they support `p[1]` and `p.σ` as well. The `LVector`, `SLVector`, `LArray`
and `SLArray` constructors also support named tuples as their arguments:

```julia
julia> LVector((a = 1, b = 2))
2-element LArray{Int64,1,(:a, :b)}:
 1
 2

julia> SLVector((a = 1, b = 2))
2-element SLArray{Tuple{2},1,(:a, :b),Int64}:
 1
 2

julia> LArray((2, 2), (a = 1, b = 2, c = 3, d = 4))
2×2 LArray{Int64,2,(:a, :b, :c, :d)}:
 1  3
 2  4

julia> SLArray{Tuple{2, 2}}((a = 1, b = 2, c = 3, d = 4))
2×2 SLArray{Tuple{2,2},2,(:a, :b, :c, :d),Int64}:
 1  3
 2  4
```

Converting to a named tuple from a labelled array x is available
using `convert(NamedTuple, x)`. Furthermore, `pairs(x)`
creates an iterator that is functionally the same as
`pairs(convert(NamedTuple, x))`, yielding `:label => x.label`
for each label of the array.

There are some crucial differences between a labelled array and
a named tuple. Labelled arrays can have any dimensions while
named tuples are always 1D. A named tuple can have different types
on each element, while an `SLArray` can only have one element
type and furthermore it has the actions of a static vector.
As a result `SLArray` has less element type information, which
improves compilation speed while giving more vector functionality
than a NamedTuple. `LArray` also only has a single element type and,
unlike a named tuple, is mutable.

## Note: Labelled slices

This functionality has been removed from LabelledArrays.jl, but can
replicated with the same compile-time performance and indexing syntax
using [DimensionalData.jl](https://rafaqz.github.io/DimensionalData.jl/stable/).

struct SLArray{S, T, N, L, Syms} <: StaticArray{S, T, N}
    __x::SArray{S, T, N, L}
    #SLArray{Syms}(__x::StaticArray{S,T,N}) where {S,N,Syms,T} = new{S,N,Syms,T}(__x)
    function SLArray{S, T, N, Syms}(__x::SArray) where {S, T, N, Syms}
        return new{S, T, N, length(__x), Syms}(convert.(T, __x))
    end
    function SLArray{S, Syms}(__x::SArray{S, T, N, L}) where {S, T, N, L, Syms}
        return new{S, T, N, L, Syms}(__x)
    end
    function SLArray{S, T, Syms}(__x::SArray{S, T, N, L}) where {S, T, N, L, Syms}
        return new{S, T, N, L, Syms}(__x)
    end
    function SLArray{S, Syms}(x::Tuple) where {S, Syms}
        __x = SArray{S}(x)
        return SLArray{S, Syms}(__x)
    end
    function SLArray{S, T, Syms}(x::Tuple) where {S, T, Syms}
        __x = SArray{S, T}(x)
        return SLArray{S, T, Syms}(__x)
    end
    function SLArray{S, T, N, L, Syms}(x::Tuple) where {S, T, N, L, Syms}
        __x = SArray{S, T, N, L}(x)
        return new{S, T, N, L, Syms}(__x)
    end
end

#####################################
# NamedTuple compatibility
#####################################
## SLArray to named tuple
function Base.convert(
        ::Type{NamedTuple},
        x::SLArray{S, T, N, L, Syms}
    ) where {S, T, N, L, Syms}
    tup = NTuple{length(Syms), T}(x.__x)
    return NamedTuple{Syms, typeof(tup)}(tup)
end
Base.keys(x::SLArray{S, T, N, L, Syms}) where {S, T, N, L, Syms} = Syms

function StaticArrays.similar_type(
        ::Type{SLArray{S, T, N, L, Syms}}, T2,
        ::Size{S}
    ) where {S, T, N, L, Syms}
    return SLArray{S, T2, N, L, Syms}
end
function RecursiveArrayTools.recursive_unitless_eltype(a::Type{T}) where {T <: SLArray}
    return StaticArrays.similar_type(a, RecursiveArrayTools.recursive_unitless_eltype(eltype(a)))
end

## Named tuple to SLArray
#=
  1. `SLArray{Tuple{2,2}}((a=1, b=2, c=3, d=4))` (need to specify size)
  2. `SLArray{Tuple{2,2}}(a=1, b=2, c=3, d=4)` : alternative form using kwargs
  3. `SLVector((a=1, b=2))` : infer size for vectors
  4. `SLVector(a=1, b=2)` : alternative form using kwargs
=#

"""
```julia
SLArray{::Tuple}(::NamedTuple)
SLArray{::Tuple}(kwargs)
```

These are the standard constructors for `SLArray`. For general N-dimensional
labelled arrays, users need to specify the size
(`Tuple{dim1,dim2,...}`) in the type parameter to the `SLArray` constructor:

```julia
julia> SLArray{Tuple{2, 2}}((a = 1, b = 2, c = 3, d = 4))
2×2 SLArray{Tuple{2, 2}, Int64, 2, 4, (:a, :b, :c, :d)} with indices SOneTo(2)×SOneTo(2):
 :a => 1  :c => 3
 :b => 2  :d => 4

julia> SLArray{Tuple{2, 2}}(a = 1, b = 2, c = 3, d = 4)
 2×2 SLArray{Tuple{2,2},2,(:a, :b, :c, :d),Int64}:
 1  3
 2  4
```

Constructing copies with some changed elements is supported by
a keyword constructor whose first argument is the source and
whose additional keyword arguments indicate the changes.

```julia
julia> ABCD = @SLArray (2, 2) (:a, :b, :c, :d);

julia> B = ABCD(1, 2, 3, 4);

julia> B2 = SLArray(B; c = 30)
2×2 SLArray{Tuple{2,2},Int64,2,4,(:a, :b, :c, :d)}:
 1  30
 2   4
```

Additional examples:

```julia
SLArray{Tuple{2, 2}}((a = 1, b = 2, c = 3, d = 4))
```
"""
function SLArray{Size}(tup::NamedTuple{Syms, Tup}) where {Size, Syms, Tup}
    __x = Tup(tup) # drop symbols
    return SLArray{Size, Syms}(__x)
end
SLArray{Size}(; kwargs...) where {Size} = SLArray{Size}(values(kwargs))

"""
```julia
SLVector(::NamedTuple)
SLVector(kwargs)
```

The standard constructors for `SLArray`.

```julia
julia> SLVector(a = 1, b = 2, c = 3)
3-element SLArray{Tuple{3},1,(:a, :b, :c),Int64}:
 1
 2
 3
```

Constructing copies with some items changed is supported by
a keyword constructor whose first argument is the source and
whose additional keyword arguments indicate the changes.

```julia
julia> v1 = SLVector(a = 1.1, b = 2.2, c = 3.3);

julia> v2 = SLVector(v1; b = 20.20, c = 30.30)
3-element SLArray{Tuple{3},Float64,1,3,(:a, :b, :c)}:
  1.1
 20.2
 30.3
```

Additional examples:

```julia
SLVector((a = 1, b = 2))
SLVector(a = 1, b = 2)
```
"""
SLVector(tup::NamedTuple) = SLArray{Tuple{length(tup)}}(tup)
SLVector(; kwargs...) = SLVector(values(kwargs))

## pairs iterator
function Base.pairs(x::SLArray{S, T, N, L, Syms}) where {S, T, N, L, Syms}
    # (label => getproperty(x, label) for label in Syms) # not type stable?
    return (Syms[i] => x[i] for i in 1:length(Syms))
end

function Base.iterate(x::SLArray, args...)
    return iterate(convert(NamedTuple, x), args...)
end

#####################################
# StaticArray Interface
#####################################
Base.@propagate_inbounds Base.getindex(x::SLArray, i::Int) = getfield(x, :__x)[i]
@inline Base.Tuple(x::SLArray) = Tuple(x.__x)

function StaticArrays.similar_type(
        ::Type{SLArray{S, T, N, L, Syms}}, ::Type{NewElType},
        ::Size{NewSize}
    ) where {
        S, T, N, L, Syms, NewElType,
        NewSize,
    }
    n = prod(NewSize)
    return if n == L
        SLArray{Tuple{NewSize...}, NewElType, length(NewSize), L, Syms}
    else
        SArray{Tuple{NewSize...}, NewElType, length(NewSize), n}
    end
end

function Base.similar(
        ::Type{SLArray{S, T, N, L, Syms}}, ::Type{NewElType},
        ::Size{NewSize}
    ) where {S, T, N, L, Syms, NewElType, NewSize}
    n = prod(NewSize)
    return if n == L
        tmp = Array{NewElType}(undef, NewSize)
        LArray{NewElType, length(NewSize), typeof(tmp), Syms}(tmp)
    else
        MArray{Tuple{NewSize...}, NewElType, length(NewSize), n}(undef)
    end
end

@inline Base.propertynames(::SLArray{S, T, N, L, Syms}) where {S, T, N, L, Syms} = Syms
@inline symnames(::Type{SLArray{S, T, N, L, Syms}}) where {S, T, N, L, Syms} = Syms
Base.@propagate_inbounds function Base.getproperty(x::SLArray, s::Symbol)
    return s == :__x || s == :data ? getfield(x, :__x) : getindex(x, Val(s))
end
Base.@propagate_inbounds function Base.getindex(x::SLArray, s::Symbol)
    return getindex(x, Val(s))
end
Base.@propagate_inbounds Base.getindex(x::SLArray, s::Val) = __getindex(x, s)
Base.@propagate_inbounds function Base.getindex(
        x::SLArray,
        inds::AbstractArray{I, 1}
    ) where {
        I <:
        Integer,
    }
    return getindex(x.__x, inds)
end
Base.@propagate_inbounds function Base.getindex(x::SLArray, inds::StaticVector{<:Any, Int})
    return getindex(x.__x, inds)
end

# Note: This could in the future return an SLArray with the right names
Base.@propagate_inbounds function Base.getindex(x::SLArray, s::AbstractArray{Symbol, 1})
    return [getindex(x, si) for si in s]
end

function Base.vcat(
        x1::SLArray{S1, T, 1, L1, Syms1},
        x2::SLArray{S2, T, 1, L2, Syms2}
    ) where {S1, S2, T, L1, L2, Syms1, Syms2}
    __x = vcat(x1.__x, x2.__x)
    return SLArray{StaticArrays.size_tuple(Size(__x)), (Syms1..., Syms2...)}(__x)
end

"""
    @SLArray Size Names
    @SLArray Eltype Size Names

The macro creates a labelled static vector with element type
`ElType`, names from `Names`, and size from `Size`. If no eltype
is given, then the eltype is determined from the arguments in the constructor.

For example:

```julia
ABCD = @SLArray (2, 2) (:a, :b, :c, :d)
x = ABCD(1.0, 2.5, 3.0, 5.0)
x.a == 1.0
x.b == 2.5
x.c == x[3]
x.d == x[2, 2]
EFG = @SLArray (2, 2) (e = 1:3, f = 4, g = 2:4)
y = EFG(1.0, 2.5, 3.0, 5.0)
EFG = @SLArray (2, 2) (e = (2, :), f = 4, g = 2:4)
```

Users can also specify the indices directly.

```julia
julia> EFG = @SLArray (2, 2) (e = 1:3, f = 4, g = 2:4);

julia> y = EFG(1.0, 2.5, 3.0, 5.0)
2×2 SLArray{Tuple{2,2},Float64,2,4,(e = 1:3, f = 4, g = 2:4)}:
 1.0  3.0
 2.5  5.0

julia> y.g
3-element view(reshape(::StaticArrays.SArray{Tuple{2,2},Float64,2,4}, 4), 2:4) with eltype Float64:
 2.5
 3.0
 5.0

julia> Arr = @SLArray (2, 2) (a = (2, :), b = 3);

julia> z = Arr(1, 2, 3, 4);

julia> z.a
2-element view(::StaticArrays.SArray{Tuple{2,2},Int64,2,4}, 2, :) with eltype Int64:
 2
 4
```
"""
macro SLArray(dims, syms)
    dims isa Expr && (dims = dims.args)
    syms = esc(syms)
    return quote
        SLArray{Tuple{$dims...}, $syms}
    end
end

macro SLArray(T, dims, syms)
    dims isa Expr && (dims = dims.args)
    syms = esc(syms)
    return quote
        SLArray{Tuple{$dims...}, $T, $(length(dims)), $(prod(dims)), $syms}
    end
end

"""
    @SLVector Names
    @SLVector Eltype Names

The macro creates a labelled static vector with element type
`ElType`, and names from `Names`. If no eltype is given,
then the eltype is determined from the values in the constructor.
The array size is found from the input data.

For example:

```julia
ABC = @SLVector (:a, :b, :c)
x = ABC(1.0, 2.5, 3.0)
x.a == 1.0
x.b == 2.5
x.c == x[3]
```
"""
macro SLVector(syms)
    syms = esc(syms)
    return quote
        n = $syms isa NamedTuple ? maximum(map(maximum, $syms)) : length($syms)
        SLArray{Tuple{n}, $syms}
    end
end

macro SLVector(T, syms)
    T = esc(T)
    syms = esc(syms)
    return quote
        n = $syms isa NamedTuple ? maximum(map(maximum, $syms)) : length($syms)
        SLArray{Tuple{n}, $T, 1, n, $syms}
    end
end

"""
    symbols(::SLArray)

Returns the labels of the `SLArray`.

For example:

```julia
julia> z = SLVector(a = 1, b = 2, c = 3)
3-element SLArray{Tuple{3}, Int64, 1, 3, (:a, :b, :c)} with indices SOneTo(3):
 :a => 1
 :b => 2
 :c => 3

julia> symbols(z)
(:a, :b, :c)
```
"""
function symbols(::SLArray{S, T, N, L, Syms}) where {S, T, N, L, Syms}
    return Syms isa NamedTuple ? keys(Syms) : Syms
end

function Base.:\(A::StaticArrays.LU, b::SLArray{S, T, N, L, Syms}) where {S, T, N, L, Syms}
    return SLArray{S, T, N, L, Syms}((A \ b.__x).data)
end

function Base.reshape(
        x::SLArray{S, T, N, L, Syms},
        ax::Tuple{SOneTo, Vararg{SOneTo}}
    ) where {
        S <: Tuple, T, N, L, Syms,
        SOneTo <: SOneTo,
    }
    return SLArray{S, T, N, L, Syms}(reshape(x.__x, ax))
end

struct LArray{T, N, D <: AbstractArray{T, N}, Syms} <: DenseArray{T, N}
    __x::D
    LArray{Syms}(__x) where {Syms} = new{eltype(__x), ndims(__x), typeof(__x), Syms}(__x)
    LArray{T, N, D, Syms}(__x) where {T, N, D, Syms} = new{T, N, D, Syms}(__x)
end

function LArray{T, N, D, Syms}(::UndefInitializer, n::Int64) where {T, N, D, Syms}
    @assert sum(lenfun, Syms) == n
    return LArray{T, N, D, Syms}(similar(D, n))
end

#####################################
# NamedTuple compatibility
#####################################
## LArray to named tuple
function Base.convert(::Type{NamedTuple}, x::LArray{T, N, D, Syms}) where {T, N, D, Syms}
    tup = NTuple{length(Syms), T}(x)
    return NamedTuple{Syms, typeof(tup)}(tup)
end
Base.keys(x::LArray{T, N, D, Syms}) where {T, N, D, Syms} = Syms

## Named tuple to LArray
#=
    1. `LArray((2,2), (a=1, b=2, c=3, d=4))` (need to specify size)
    2. `LArray((2,2); a=1, b=2, c=3, d=4)` : alternative form using kwargs
    3. `LVector((a=1, b=2))` : can infer size for vectors
    4. `LVector(a=1, b=2)` : alternative form using kwargs
=#
"""
```julia
LArray(::Tuple, ::NamedTuple)
LArray(::Tuple, kwargs)
```

The standard constructors for `LArray`.

For example:

```julia
LArray((2, 2), (a = 1, b = 2, c = 3, d = 4))  # need to specify size
LArray((2, 2); a = 1, b = 2, c = 3, d = 4)
```
"""
function LArray(size::NTuple{S, Int}, tup::NamedTuple{Syms, Tup}) where {S, Syms, Tup}
    __x = reshape(collect(tup), size)
    return LArray{Syms}(__x)
end
LArray(size::NTuple{S, Int}; kwargs...) where {S} = LArray(size, values(kwargs))

"""
```julia
LVector(::NamedTuple)
LVector(kwargs)
```

The standard constructor for `LVector`.

For example:

```julia
LVector((a = 1, b = 2))
LVector(a = 1, b = 2)
```
"""
LVector(tup::NamedTuple) = LArray((length(tup),), tup)
LVector(; kwargs...) = LVector(values(kwargs))

## pairs iterator
function Base.pairs(x::LArray{T, N, D, Syms}) where {T, N, D, Syms}
    # (label => getproperty(x, label) for label in Syms) # not type stable?
    return (Syms[i] => x[i] for i in 1:length(Syms))
end

#####################################
# Array Interface
#####################################
Base.size(x::LArray) = size(getfield(x, :__x))
Base.@propagate_inbounds Base.getindex(x::LArray, i...) = getfield(x, :__x)[i...]
Base.@propagate_inbounds function Base.setindex!(x::LArray, y, i...)
    getfield(x, :__x)[i...] = y
    return x
end

Base.propertynames(::LArray{T, N, D, Syms}) where {T, N, D, Syms} = Syms
symnames(::Type{LArray{T, N, D, Syms}}) where {T, N, D, Syms} = Syms

Base.@propagate_inbounds function Base.getproperty(x::LArray, s::Symbol)
    if s == :__x
        return getfield(x, :__x)
    end
    return getindex(x, Val(s))
end

Base.@propagate_inbounds function Base.setproperty!(x::LArray, s::Symbol, y)
    if s == :__x
        return setfield!(x, :__x, y)
    end
    return setindex!(x, y, Val(s))
end

Base.@propagate_inbounds Base.getindex(x::LArray, s::Symbol) = getindex(x, Val(s))
Base.@propagate_inbounds Base.getindex(x::LArray, s::Val) = __getindex(x, s)
Base.@propagate_inbounds Base.setindex!(x::LArray, v, s::Symbol) = setindex!(x, v, Val(s))

@generated function Base.setindex!(x::LArray, y, ::Val{s}) where {s}
    syms = symnames(x)
    if syms isa NamedTuple
        idxs = syms[s]
        return quote
            Base.@_propagate_inbounds_meta
            setindex!(getfield(x, :__x), y, $idxs)
            return x
        end
    else # Tuple
        idx = findfirst(y -> y == s, symnames(x))
        return quote
            Base.@_propagate_inbounds_meta
            setindex!(getfield(x, :__x), y, $idx)
            return x
        end
    end
end

Base.@propagate_inbounds function Base.getindex(x::LArray, s::AbstractArray{Symbol, 1})
    return [getindex(x, si) for si in s]
end

function Base.similar(
        x::LArray{T, K, D, Syms}, ::Type{S},
        dims::NTuple{N, Int}
    ) where {T, K, D, Syms, S, N}
    tmp = similar(x.__x, S, dims)
    return LArray{S, N, typeof(tmp), Syms}(tmp)
end

# Allow copying LArray of uninitialized data, as with regular Array
Base.copy(x::LArray) = typeof(x)(copy(getfield(x, :__x)))
Base.copyto!(x::LArray, y::LArray) = copyto!(getfield(x, :__x), getfield(y, :__x))

# enable the usage of LAPACK
function Base.unsafe_convert(::Type{Ptr{T}}, a::LArray{T, N, D, S}) where {T, N, D, S}
    return Base.unsafe_convert(Ptr{T}, getfield(a, :__x))
end

Base.convert(::Type{T}, x) where {T <: LArray} = T(x)
Base.convert(::Type{T}, x::T) where {T <: LArray} = x
Base.convert(::Type{<:Array}, x::LArray) = convert(Array, getfield(x, :__x))
function Base.convert(
        ::Type{AbstractArray{T, N}},
        x::LArray{S, N, <:Any, Syms}
    ) where {T, S, N, Syms}
    return LArray{Syms}(convert(AbstractArray{T, N}, getfield(x, :__x)))
end
Base.convert(::Type{AbstractArray{T, N}}, x::LArray{T, N}) where {T, N} = x

function ArrayInterface.restructure(
        x::LArray{T, N, D, Syms},
        y::LArray{T2, N2, D2, Syms}
    ) where {
        T, N, D, T2, N2,
        D2,
        Syms,
    }
    return reshape(y, size(x)...)
end

#####################################
# Broadcast
#####################################
struct LAStyle{T, N, L} <: Broadcast.AbstractArrayStyle{N} end
LAStyle{T, N, L}(x::Val{i}) where {T, N, L, i} = LAStyle{T, N, L}()
Base.BroadcastStyle(::Type{LArray{T, N, D, L}}) where {T, N, D, L} = LAStyle{T, N, L}()
function Base.BroadcastStyle(
        ::LabelledArrays.LAStyle{T, N, L},
        ::LabelledArrays.LAStyle{E, N, L}
    ) where {T, E, N, L}
    return LAStyle{promote_type(T, E), N, L}()
end

@generated function labels2axes(::Val{t}) where {t}
    return if t isa NamedTuple && all(x -> x isa Union{Integer, UnitRange}, values(t)) # range labelling
        (Base.OneTo(maximum(Iterators.flatten(v for v in values(t)))),)
    elseif t isa NTuple{<:Any, Symbol}
        axes(t)
    else
        error("$t label isn't supported for broadcasting. Try to formulate it in terms of linear indexing.")
    end
end
function Base.similar(
        bc::Broadcast.Broadcasted{LAStyle{T, N, L}},
        ::Type{ElType}
    ) where {T, N, L, ElType}
    tmp = similar(Array{ElType}, axes(bc))
    if axes(bc) != labels2axes(Val(L))
        return tmp
    else
        return LArray{ElType, N, typeof(tmp), L}(tmp)
    end
end

# Broadcasting checks for aliasing with Base.dataids but the fallback
# for AbstractArrays is very slow. Instead, we just call dataids on the
# wrapped buffer
Base.dataids(A::LArray) = Base.dataids(A.__x)

"""
```julia
@LArray Eltype Size Names
@LArray Values Names
```

The `@LArray` macro creates an `LArray` with names determined from the `Names`
vector and values determined from the `Values` vector. Otherwise, the eltype
and size are used to make an `LArray` with undefined values.

```julia
A = @LArray [1, 2, 3] (:a, :b, :c)
A.a == 1
```

Users can also generate a labelled array with undefined values by instead giving
the dimensions. This approach is useful if the user intends to pre-allocate an
array for some later input.

```julia
A = @LArray Float64 (2, 2) (:a, :b, :c, :d)
W = rand(2, 2)
A .= W
A.d == W[2, 2]
```

Users may also use an alternative constructor to set the Names and Values
and ranges at the same time.

```julia
julia> z = @LArray [1.0, 2.0, 3.0] (a = 1:2, b = 2:3);

julia> z.b
2-element view(::Array{Float64,1}, 2:3) with eltype Float64:
 2.0
 3.0

julia> z = @LArray [1 2; 3 4] (a = (2, :), b = 2:3);

julia> z.a
2-element view(::Array{Int64,2}, 2, :) with eltype Int64:
 3
 4
```

The labels of LArray and SLArray can be accessed
by function `symbols`, which returns a tuple of symbols.
"""
macro LArray(vals, syms)
    vals = esc(vals)
    syms = esc(syms)
    return quote
        LArray{$syms}($vals)
    end
end

macro LArray(type, size, syms)
    type = esc(type)
    size = esc(size)
    syms = esc(syms)
    return quote
        LArray{$syms}(Array{$type}(undef, $size...))
    end
end

"""
```julia
@LVector Type Names
```

The `@LVector` macro creates an `LArray` of dimension 1 with eltype and undefined values.
The vector's length is equal to the number of names given.

As with an `LArray`, the user can initialize the vector and set its values later.

```julia
A = @LVector Float64 (:a, :b, :c, :d)
A .= rand(4)
```

To initialize the vector and set its values at the
same time, use [`@LArray`](@ref) instead:

```julia
b = @LArray [1, 2, 3] (:a, :b, :c)
```
"""
macro LVector(type, syms)
    type = esc(type)
    syms = esc(syms)
    return quote
        LArray{$syms}(Vector{$type}(undef, length($syms)))
    end
end

#the following gives error: TypeError: in <:, expected Type, got TypeVar
#symbols(::LArray{T,N,D<:AbstractArray{T,N},Syms}) where {T,N,D,Syms} = Syms

"""
    symbols(::LArray)

Returns the labels of the `LArray`.

For example:

```julia
julia> z = @LVector Float64 (:a, :b, :c, :d);

julia> symbols(z)
(:a, :b, :c, :d)
```
"""
function symbols(::LArray{T, N, D, Syms}) where {T, N, D, Syms}
    return Syms isa NamedTuple ? keys(Syms) : Syms
end

# copy constructors

"""
    LVector(v1::Union{SLArray,LArray}; kwargs...)

Creates a 1D copy of v1 with corresponding items in kwargs replaced.

For example:

    z = LVector(a=1, b=2, c=3);
    z2 = LVector(z; c=30)
"""
function LVector(v1::Union{SLArray, LArray}; kwargs...)
    t2 = merge(convert(NamedTuple, v1), values(kwargs))
    return LVector(t2)
end

"""
    LVector(v1::Union{SLArray,LArray}; kwargs...)

Creates a copy of v1 with corresponding items in kwargs replaced.

For example:

    ABCD = @SLArray (2,2) (:a,:b,:c,:d);
    B = ABCD(1,2,3,4);
    B2 = LArray(B; c=30 )
"""
function LArray(v1::Union{SLArray, LArray}; kwargs...)
    t2 = merge(convert(NamedTuple, v1), values(kwargs))
    return LArray(size(v1), t2)
end

# moved vom slarray.js to here because LArray need to be known
"""
    SLVector(v1::SLArray; kwargs...)

Creates a 1D copy of v1 with corresponding items in kwargs replaced.

For example:

    z = SLVector(a=1, b=2, c=3);
    z2 = SLVector(z; c=30)
"""
function SLVector(v1::Union{SLArray, LArray}; kwargs...)
    t2 = merge(convert(NamedTuple, v1), values(kwargs))
    return SLVector(t2)
end

"""
    SLVector(v1::SLArray; kwargs...)

Creates a copy of v1 with corresponding items in kwargs replaced.

For example:

    ABCD = @SLArray (2,2) (:a,:b,:c,:d);
    B = ABCD(1,2,3,4);
    B2 = SLArray(B; c=30 )
"""
function SLArray(
        v1::Union{SLArray{S, T, N, L, Syms}, LArray{T, N, D, Syms}};
        kwargs...
    ) where {S, T, N, L, Syms, D}
    t2 = merge(convert(NamedTuple, v1), values(kwargs))
    return SLArray{S}(t2)
end

function Base.vcat(x::LArray, y::LArray)
    return LArray{(LabelledArrays.symnames(typeof(x))..., LabelledArrays.symnames(typeof(y))...)}(
        vcat(
            x.__x,
            y.__x
        )
    )
end

Base.elsize(::Type{<:LArray{T}}) where {T} = sizeof(T)

function RecursiveArrayTools.recursive_unitless_eltype(
        a::Type{
            LArray{
                T, N, D, Syms,
            },
        }
    ) where {
        T,
        N,
        D,
        Syms,
    }
    return LArray{typeof(one(T)), N, D, Syms}
end

using RecursiveArrayTools, LabelledArrays, Test

ABC = @SLVector (:a, :b, :c);
A = ABC(1, 2, 3);
B = RecursiveArrayTools.DiffEqArray([A, A], [0.0, 2.0]);
@test getindex(B, :a) == [1, 1]

B_with_parameters = RecursiveArrayTools.DiffEqArray([A, A], [0.0, 2.0], (1,))
@test getindex(B_with_parameters, :b) == [2, 2]

using LabelledArrays, StaticArrays
using Test, InteractiveUtils

@testset "Basic interface" begin
    ABC = @SLVector (:a, :b, :c)
    b = ABC(1, 2, 3)
    @test_nowarn display(b)
    @test vec(b) === b

    @test b.a == 1
    @test b.b == 2
    @test b.c == 3
    @test b[1] == b.a
    @test b[2] == b.b
    @test b[3] == b.c

    @test_throws ErrorException b.d
    @test_throws UndefVarError fill!(a, 1)
    @test typeof(b.__x) == SVector{3, Int}

    # Type stability tests
    ABC_fl = @SLVector Float64 (:a, :b, :c)
    ABC_int = @SLVector Int (:a, :b, :c)

    @test @inferred(similar_type(b, Float64)) === ABC_fl
    @test @inferred(similar_type(b, Float64, Size(1, 3))) ===
        @SLArray Float64 (1, 3) (:a, :b, :c)
    @test @inferred(similar_type(b, Float64, Size(3, 3))) ===
        SArray{Tuple{3, 3}, Float64, 2, 9}

    @test typeof(@inferred(similar(b))) === LArray{Int, 1, Array{Int64, 1}, (:a, :b, :c)}
    @test typeof(@inferred(similar(b, Float64))) ===
        LArray{Float64, 1, Array{Float64, 1}, (:a, :b, :c)}
    @test typeof(@inferred(similar(b, Size(1, 3)))) ===
        LArray{Int, 2, Array{Int64, 2}, (:a, :b, :c)}
    @test typeof(@inferred(similar(b, Size(3, 3)))) === MArray{Tuple{3, 3}, Int, 2, 9}

    @test @inferred(copy(b)) === ABC_int(Tuple(b))

    @test @inferred(broadcast(Float64, b)) === ABC_fl(Tuple(b))
    @test @inferred(broadcast(+, b, b)) === ABC_int(Tuple(b.__x .+ b.__x))
    @test @inferred(broadcast(+, b, 1.0)) === ABC_fl(Tuple(b.__x .+ 1.0))

    @test @inferred(zero(b)) === ABC_int(zero(b))
end

@testset "NamedTuple conversion" begin
    x_tup = (a = 1, b = 2)
    y_tup = (a = 1, b = 2, c = 3, d = 4)
    x = SLVector(a = 1, b = 2)
    y = SLArray{Tuple{2, 2}}(a = 1, b = 2, c = 3, d = 4)
    @test vec(y) === SLVector(a = 1, b = 2, c = 3, d = 4)
    @test @inferred(convert(NamedTuple, x)) == x_tup
    @test @inferred(convert(NamedTuple, y)) == y_tup
    @test NamedTuple(x) == x_tup
    @test NamedTuple(y) == y_tup
    @test @inferred(collect(pairs(x))) == collect(pairs(x_tup))
    @test @inferred(collect(pairs(y))) == collect(pairs(y_tup))

    @inferred(SLArray{Tuple{2, 2}}(a = 1, b = 2, c = 3, d = 4))
    @inferred(convert(NamedTuple, y))
    @inferred(collect(pairs(y)))
end

@testset "accessing labels, i.e. symbols" begin
    z = SLVector(a = 1, b = 2, c = 3)
    ret = symbols(z)
    @test ret == (:a, :b, :c)
end

@testset "Explicit indices" begin
    Arr = @SLVector (a = 1:2, b = 3)
    z = Arr(1.0, 2.0, 3.0)
    @test_nowarn display(z)
    g(z) = z.a
    @inferred g(z)
    @test z.a isa SubArray
    @test z.a == [1, 2.0]
    @test z.b === 3.0
    Arr = @SLVector (a = 1:2, b = 2:3)
    z = Arr(1.0, 2.0, 3.0)
    @test_nowarn display(z)
    @test z.b == [2, 3.0]
    Arr = @SLVector (a = 1, b = 2)
    z = Arr(1, 2)
    @test_nowarn display(z)
    @test z.a === 1
    @test z.b === 2
    @test symbols(z) === (:a, :b)
    Arr = @SLArray (2, 2) (a = (2, :), b = 3)
    z = Arr(1, 2, 3, 4)
    @test_nowarn display(z)
    @test z.a == [2, 4]
end

@testset "Concatenate and Iterate" begin
    x = SLVector(a = 1, b = 2)
    y = SLVector(c = 1, d = 2)
    @test (x..., y...) == (1, 2, 1, 2)
    @test typeof(vcat(x, y)) <: SLArray
end

@testset "convert" begin
    A = (@SLVector (:a, :b, :c))(1, 2, 3)
    @test convert(AbstractVector{Int}, A) === A
    B = convert(AbstractVector{Float64}, A)
    @test B.b === 2.0
end

@testset "recursive_unitless_eltype" begin
    import RecursiveArrayTools
    ABC = @SLVector (:a, :b, :c)
    x = ABC(1.0, 2.0, 3.0)
    result = RecursiveArrayTools.recursive_unitless_eltype(typeof(x))
    @test result <: SLArray
end

@testset "Vector" begin
    x = randn(2)
    syms = (:a, :b)

    # Constructors
    test_rrule(LArray{syms}, x)
    constructor = @SLArray (2,) syms
    test_rrule(constructor, x)

    # `getproperty`
    lx = LArray{syms}(x)
    test_rrule(getproperty, lx, first(syms))
    test_rrule(getproperty, lx, last(syms))

    slx = constructor(x)
    test_rrule(getproperty, slx, first(syms))
    test_rrule(getproperty, slx, last(syms))
end

using LabelledArrays, Test, InteractiveUtils

@testset "Basic interface" begin
    vals = [1.0, 2.0, 3.0]
    syms = (:a, :b, :c)
    x = @LArray vals syms
    @test Base.elsize(x) == Base.elsize(vals) == 8
    @test_nowarn display(x)
    y = @LVector Float64 (:a, :b, :c)
    y .= [1, 2, 3.0]
    @test x == y
    @test vec(x) === x
    @test vec(y) === y
    mat = rand(4, 3)
    @test mat * vals ≈ mat * [1.0, 2.0, 3.0]
    syms = (:a, :b, :c)
    @test typeof(typeof(x)(undef, 3)) == typeof(x)

    z = LabelledArrays.LArray{Float64, 1, Vector{Float64}, (x = 1:4, y = 5:8)}(undef, 8)
    @test length(z) == 8
    @test size(LabelledArrays.ArrayInterface.undefmatrix(z)) == (8, 8)

    for (i, s) in enumerate(syms)
        @show i, s
        @test x[i] == x[s]
    end

    x[:a]

    f(x) = x[1]
    g(x) = x.a
    g(x, y) = x.a = y
    @time f(x)
    @time f(x)
    @time g(x)
    @time g(x)

    #@code_warntype x.a
    #@inferred getindex(x,:a)
    @code_warntype g(x)
    @inferred g(x)
    @inferred g(x, 2)

    vals = [1, 2, 3]
    syms = (:a, :b, :c)
    x = @LArray vals syms
    @test x .* x isa LArray
    @test x * x' isa Array
    @test x .+ 1 isa LArray
    @test x .+ 1.0 isa LArray
    z = x .+ ones(Int, 3)
    @test z isa LArray && eltype(z) === Int
    z = x .+ ones(Float64, 3)
    @test z isa LArray && eltype(z) === Float64
    @test eltype(x .+ 1.0) === Float64
    @test Base.dataids(vals) == Base.dataids(x)

    type = Float64
    dims = (2, 2)
    syms = (:a, :b, :c, :d)
    z = @LArray type dims syms
    w = rand(2, 2)
    z .= w

    @test z[:a] == w[1, 1]
    @test z[:b] == w[2, 1]
    @test z[:c] == w[1, 2]
    @test z[:d] == w[2, 2]

    @test setindex!(x, 2, :a) == LVector(a = 2, b = 2, c = 3)
    @test setindex!(x, 2, :a) == LVector(a = 2, b = 2, c = 3)
    @test setindex!(LArray((2, 2), a = 1, b = 2, c = 3, d = 4), 1, :b) ==
        LArray((2, 2), a = 1, b = 1, c = 3, d = 4)

    x = @LArray [1, 2, 3] (:a, :b, :c)
    y = @LArray [4, 5, 6] (:d, :e, :f)
    @test LabelledArrays.symnames(typeof(vcat(x, y))) == (:a, :b, :c, :d, :e, :f)
    @test vcat(x, y) == [1, 2, 3, 4, 5, 6]

    @test_throws ErrorException x.z

    # Ref #93, #154
    @test_broken @LVector [1, 2, 3] (:a, :b, :c)
end

@testset "Alternate array backends" begin
    v = view([1 2 3 4 5 6 7 8], 3:6)
    x = LArray{(:a, :b, :c, :d)}(v)
    @test x.b == 4
    @test x[:d] == 6

    s = similar(x)
    @test size(s) == size(x)
    @test typeof(s.__x) == Array{Int64, 1}
    @test LabelledArrays.symnames(typeof(s)) == (:a, :b, :c, :d)
end

@testset "NameTuple conversion" begin
    x_tup = (a = 1, b = 2)
    y_tup = (a = 1, b = 2, c = 3, d = 4)
    x = LVector(a = 1, b = 2)
    y = LArray((2, 2); a = 1, b = 2, c = 3, d = 4)
    @test convert(NamedTuple, x) == x_tup
    @test convert(NamedTuple, y) == y_tup
    @test NamedTuple(x) == x_tup
    @test NamedTuple(y) == y_tup
    @test collect(pairs(x)) == collect(pairs(x_tup))
    @test collect(pairs(y)) == collect(pairs(y_tup))

    @code_warntype LArray((2, 2); a = 1, b = 2, c = 3, d = 4)
    @code_warntype convert(NamedTuple, y)
    @code_warntype collect(pairs(y))
end

@testset "undef copy" begin
    z = @LArray Float64 (2, 2) (:a, :b, :c, :d)
    t = similar(z, String) # t's elements are uninitialized
    @test_throws UndefRefError t[1]
    copy(t) # should be ok
    deepcopy(t) # should also be ok
end

@testset "accessing labels, i.e. symbols" begin
    z = @LArray Float64 (2, 2) (:a, :b, :c, :d)
    @test_nowarn display(z)
    ret = symbols(z)
    @test ret == (:a, :b, :c, :d)
    #ret2 = dimSymbols(z,1) # no method defined if Syms is not a tuple
end

@testset "several indices as vector" begin
    z = @LArray [1.0, 2.0, 3.0] (:a, :b, :c)
    @test z[[3, 1]] == [3.0, 1.0]
    @test z[[:c, :a]] == [3.0, 1.0]
    #i = LabelledArrays.symToInd(z, (:c,:a)) # also works with Tuples
    zs = SLVector(a = 1.0, b = 2.0, c = 3.0)
    @test zs[[3, 1]] == [3.0, 1.0]
    @test zs[[:c, :a]] == [3.0, 1.0]
end

@testset "Explicit indices" begin
    z = @LArray [1.0, 2.0, 3.0] (a = 1:2, b = 3)
    @test z * z' isa Array
    g(x) = x.a
    g(x, y) = x.a .= y
    @inferred g(z)
    @test_broken @inferred g(z, [1, 2])
    @test_nowarn display(z)
    @test z.a isa SubArray
    @test z.a == [1, 2.0]
    z.a = [100, 200.0]
    @test z.a == [100, 200.0]
    @test z.b === 3.0
    z.b = 1000.0
    @test z.b === 1000.0
    z = @LArray [1.0, 2.0, 3.0] (a = 1:2, b = 1:3)
    @inferred g(z)
    @test_broken @inferred g(z, [1, 2.0])
    @test z.b === view(z.__x, 1:3)
    z = @LArray [1.0, 2.0] (a = 1, b = 2)
    @test_nowarn display(z)
    @test z.a === 1.0
    @test z.b === 2.0
    @test symbols(z) === (:a, :b)
    z = @LArray [1 2; 3 4] (a = (2, :), b = 2:3)
    @test z.a == [3, 4]
    @test_nowarn display(z)
    @inferred g(z)
    @test_broken @inferred g(z, [1, 2])
end

@testset "1x1 broadcasting" begin
    x = @LArray [1] (:a,)
    @test x .* 1 == x
    @test x .* 1 isa LArray
    @test x .* x' == fill(1, 1, 1)
    @test x .* x' isa Array
end

@testset "broadcasting" begin
    n = 2
    lu_0 = @LArray fill(1000.0, 2 * n) (x = (1:n), y = ((n + 1):(2 * n)))
    @test lu_0 ./ 1.0 isa LArray

    x = @LArray fill(1000.0, 2 * n) (:x1, :x2, :y1, :y2)
    @test x ./ 1.0 isa LArray
end

@testset "convert" begin
    A = @LArray [1, 2, 3] (:a, :b, :c)
    @test convert(AbstractVector{Int}, A) === A
    B = convert(AbstractVector{Float64}, A)
    @test B.b === 2.0
end

@testset "DiffCache get_tmp with LArray" begin
    using PreallocationTools, ForwardDiff
    la = @LVector Float64 (:a, :b, :c)
    la .= [1.0, 2.0, 3.0]
    # Use chunk size 1 but pass Duals with chunk size 3 to trigger cache enlargement
    dc = DiffCache(zeros(3), 1)
    T = ForwardDiff.Dual{Nothing, Float64, 3}
    dual_la = LArray{T, 1, Vector{T}, (:a, :b, :c)}(T.(la.__x))
    result = get_tmp(dc, dual_la)
    @test result isa LArray
    @test eltype(result) === T
end

using LabelledArrays
using AllocCheck
using Test
using StaticArrays

@testset "AllocCheck - Zero Allocation Tests" begin
    @testset "SLArray (Static) Zero Allocations" begin
        sv = SLVector(a = 1.0, b = 2.0, c = 3.0)
        sm = (@SLArray (2, 2) (:a, :b, :c, :d))(1.0, 2.0, 3.0, 4.0)

        # Property access should be allocation-free
        @check_allocs function test_slarray_property_a(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            arr.a
        end
        @test test_slarray_property_a(sv) == 1.0

        # Integer indexing should be allocation-free
        @check_allocs function test_slarray_getindex_int(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}, i::Int
            )
            arr[i]
        end
        @test test_slarray_getindex_int(sv, 1) == 1.0
        @test test_slarray_getindex_int(sv, 2) == 2.0
        @test test_slarray_getindex_int(sv, 3) == 3.0

        # Val-based symbol access should be allocation-free
        @check_allocs function test_slarray_getindex_val(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            getindex(arr, Val(:a))
        end
        @test test_slarray_getindex_val(sv) == 1.0

        # Broadcasting between SLArrays should be allocation-free
        sv2 = SLVector(a = 4.0, b = 5.0, c = 6.0)
        @check_allocs function test_slarray_broadcast_add(
                arr1::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)},
                arr2::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            arr1 .+ arr2
        end
        result = test_slarray_broadcast_add(sv, sv2)
        @test result.a == 5.0
        @test result.b == 7.0
        @test result.c == 9.0

        # Scalar broadcasting should be allocation-free
        @check_allocs function test_slarray_broadcast_scalar(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}, x::Float64
            )
            arr .* x
        end
        result = test_slarray_broadcast_scalar(sv, 2.0)
        @test result.a == 2.0
        @test result.b == 4.0
        @test result.c == 6.0

        # NamedTuple conversion should be allocation-free
        @check_allocs function test_slarray_namedtuple(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            convert(NamedTuple, arr)
        end
        nt = test_slarray_namedtuple(sv)
        @test nt == (a = 1.0, b = 2.0, c = 3.0)

        # copy should be allocation-free for SLArray
        @check_allocs function test_slarray_copy(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            copy(arr)
        end
        @test test_slarray_copy(sv) == sv

        # symbols function should be allocation-free
        @check_allocs function test_slarray_symbols(
                arr::SLArray{Tuple{3}, Float64, 1, 3, (:a, :b, :c)}
            )
            symbols(arr)
        end
        @test test_slarray_symbols(sv) == (:a, :b, :c)

        # 2D SLArray property access should be allocation-free
        @check_allocs function test_slarray_2d_property(
                arr::SLArray{Tuple{2, 2}, Float64, 2, 4, (:a, :b, :c, :d)}
            )
            arr.c
        end
        @test test_slarray_2d_property(sm) == 3.0
    end

    @testset "LArray (Mutable) Zero Allocations" begin
        lv = LVector(a = 1.0, b = 2.0, c = 3.0)
        lm = @LArray Float64 (2, 2) (:a, :b, :c, :d)
        lm .= reshape([1.0, 2.0, 3.0, 4.0], 2, 2)

        # Property access should be allocation-free
        @check_allocs function test_larray_property_a(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            arr.a
        end
        @test test_larray_property_a(lv) == 1.0

        # Integer indexing should be allocation-free
        @check_allocs function test_larray_getindex_int(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}, i::Int
            )
            arr[i]
        end
        @test test_larray_getindex_int(lv, 1) == 1.0
        @test test_larray_getindex_int(lv, 2) == 2.0
        @test test_larray_getindex_int(lv, 3) == 3.0

        # Val-based symbol access should be allocation-free
        @check_allocs function test_larray_getindex_val(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            getindex(arr, Val(:a))
        end
        @test test_larray_getindex_val(lv) == 1.0

        # Property write should be allocation-free
        @check_allocs function test_larray_setproperty(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}, val::Float64
            )
            arr.a = val
        end
        test_larray_setproperty(lv, 10.0)
        @test lv.a == 10.0
        lv.a = 1.0  # Reset

        # Integer setindex should be allocation-free
        @check_allocs function test_larray_setindex_int(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}, val::Float64, i::Int
            )
            arr[i] = val
        end
        test_larray_setindex_int(lv, 20.0, 1)
        @test lv[1] == 20.0
        lv[1] = 1.0  # Reset

        # Note: In-place broadcasting (dest .= src .+ 1.0) shows 0 allocations
        # with @btime but AllocCheck detects internal broadcasting machinery allocations.
        # This is a limitation of Julia's broadcast implementation, not LabelledArrays.

        # copyto! should be allocation-free
        lv_dest2 = LVector(a = 0.0, b = 0.0, c = 0.0)
        @check_allocs function test_larray_copyto!(
                dest::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)},
                src::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            copyto!(dest, src)
        end
        test_larray_copyto!(lv_dest2, lv)
        @test lv_dest2 == lv

        # NamedTuple conversion should be allocation-free
        @check_allocs function test_larray_namedtuple(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            convert(NamedTuple, arr)
        end
        nt = test_larray_namedtuple(lv)
        @test nt == (a = 1.0, b = 2.0, c = 3.0)

        # symbols function should be allocation-free
        @check_allocs function test_larray_symbols(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            symbols(arr)
        end
        @test test_larray_symbols(lv) == (:a, :b, :c)

        # 2D LArray property access should be allocation-free
        @check_allocs function test_larray_2d_property(
                arr::LArray{Float64, 2, Matrix{Float64}, (:a, :b, :c, :d)}
            )
            arr.c
        end
        @test test_larray_2d_property(lm) == 3.0

        # size should be allocation-free
        @check_allocs function test_larray_size(
                arr::LArray{Float64, 1, Vector{Float64}, (:a, :b, :c)}
            )
            size(arr)
        end
        @test test_larray_size(lv) == (3,)
    end

    @testset "Range-Based Labels Zero Allocations" begin
        # Range-based label access returns views which should be allocation-free
        lv_range = @LArray [1.0, 2.0, 3.0, 4.0, 5.0, 6.0] (x = 1:3, y = 4:6)

        # Note: Range-based property access returns a view, which should be allocation-free
        @check_allocs function test_range_property(
                arr::LArray{Float64, 1, Vector{Float64}, (x = 1:3, y = 4:6)}
            )
            arr.x
        end
        v = test_range_property(lv_range)
        @test v == [1.0, 2.0, 3.0]
    end
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "Home" => "index.md",
    "Example: Nice DiffEq Syntax Without A DSL" => "Example_dsl.md",
    "SLArrays" => "SLArrays.md",
    "LArrays" => "LArrays.md",
    "Relation to NamedTuples" => "NamedTuples_relation.md",
    "Note: Labelled Slices" => "Note_labelled_slices.md",
]

module LabelledArrays

using LinearAlgebra, StaticArrays, ArrayInterface
import RecursiveArrayTools, PreallocationTools, ForwardDiff

include("slarray.jl")
include("larray.jl")
include("chainrules.jl")
include("diffeqarray.jl")

# Common
@generated function __getindex(x::Union{LArray, SLArray}, ::Val{s}) where {s}
    syms = symnames(x)
    idx = syms isa NamedTuple ? syms[s] : findfirst(y -> y == s, syms)
    return if idx === nothing
        :(error("type $(typeof(x)) has no field $(s)"))
    elseif idx isa Tuple
        :(Base.@_propagate_inbounds_meta; view(getfield(x, :__x), $idx...))
    else
        :(Base.@_propagate_inbounds_meta; @views getfield(x, :__x)[$idx])
    end
end

using MacroTools

struct PrintWrapper{T, N, F, X <: AbstractArray{T, N}} <: AbstractArray{T, N}
    f::F
    x::X
end

import Base: eltype, length, ndims, size, axes, eachindex, stride, strides
MacroTools.@forward PrintWrapper.x eltype, length, ndims, size, axes, eachindex, stride,
    strides
Base.getindex(A::PrintWrapper, idxs...) = A.f(A.x, A.x[idxs...], idxs)

function lazypair(A, x, idxs)
    syms = symnames(typeof(A))
    II = LinearIndices(A)
    key = eltype(syms) <: Symbol ? syms[II[idxs...]] :
        findfirst(syms) do sym
            ii = idxs isa Tuple ? II[idxs...] : II[idxs]
            sym isa Tuple ? ii in II[sym...] : ii in II[sym]
    end
    return key => x
end

Base.show(io::IO, ::MIME"text/plain", x::Union{LArray, SLArray}) = show(io, x)
function Base.show(io::IO, x::Union{LArray, SLArray})
    syms = symnames(typeof(x))
    n = length(syms)
    pwrapper = PrintWrapper(lazypair, x)
    if io isa IOContext && get(io, :limit, false) &&
            displaysize(io) isa Tuple{Integer, Integer}
        io = IOContext(io, :limit => true, :displaysize => cld.(2 .* displaysize(io), 3))
    end
    println(io, summary(x), ':')
    return Base.print_array(io, pwrapper)
end

Base.NamedTuple(x::Union{LArray, SLArray}) = NamedTuple{symnames(typeof(x))}(x.__x)
@inline Base.reshape(a::SLArray, s::Size) = StaticArrays.similar_type(a, s)(Tuple(a))

function ArrayInterface.ismutable(::Type{<:LArray{T, N, D, Syms}}) where {T, N, D, Syms}
    return ArrayInterface.ismutable(T)
end
ArrayInterface.can_setindex(::Type{<:SLArray}) = false

lenfun(x) = length(x)
lenfun(::Symbol) = 1
function ArrayInterface.undefmatrix(x::LArray{T, N, D, Syms}) where {T, N, D, Syms}
    n = sum(lenfun, Syms)
    return similar(x.__x, n, n)
end

function PreallocationTools.get_tmp(
        dc::PreallocationTools.DiffCache,
        u::LArray{T, N, D, Syms}
    ) where {
        T <: ForwardDiff.Dual,
        N, D, Syms,
    }
    nelem = div(sizeof(T), sizeof(eltype(dc.dual_du))) * length(dc.du)
    if nelem > length(dc.dual_du)
        PreallocationTools.enlargediffcache!(dc, nelem)
    end
    _x = ArrayInterface.restructure(dc.du, reinterpret(T, view(dc.dual_du, 1:nelem)))
    return LabelledArrays.LArray{T, N, D, Syms}(_x)
end

export SLArray, LArray, SLVector, LVector, @SLVector, @LArray, @LVector, @SLArray

export @SLSliced, @LSliced

export symbols, dimSymbols, rowSymbols, colSymbols

include("precompilation.jl")

end # module

using PrecompileTools

@setup_workload begin
    @compile_workload begin
        # LArray operations - Float64
        x = @LArray [1.0, 2.0, 3.0] (:a, :b, :c)
        _ = x.a
        _ = x.b
        x.a = 2.0
        _ = symbols(x)

        # LVector creation
        lv = LVector(a = 1.0, b = 2.0, c = 3.0)
        _ = lv.a

        # @LVector macro
        lv2 = @LVector Float64 (:x, :y, :z)
        lv2 .= [1.0, 2.0, 3.0]

        # Broadcasting with LArray (major TTFX cost)
        y = @LArray [4.0, 5.0, 6.0] (:a, :b, :c)
        _ = x .+ y
        _ = x .* 2.0
        _ = x .+ 1.0

        # SLArray operations - Float64
        SLV = @SLVector Float64 (:a, :b, :c)
        sv = SLV(1.0, 2.0, 3.0)
        _ = sv.a
        _ = sv.b
        _ = symbols(sv)

        # SLArray 2D
        SLA = @SLArray Float64 (2, 2) (:a, :b, :c, :d)
        sa = SLA(1.0, 2.0, 3.0, 4.0)
        _ = sa.a
        _ = sa.d

        # SLVector operations
        sv2 = SLVector(a = 1.0, b = 2.0)
        _ = sv2.a

        # Conversion and copy operations
        _ = convert(NamedTuple, x)
        _ = convert(NamedTuple, sv)
        _ = copy(x)

        # show methods (for REPL display)
        io = IOBuffer()
        show(io, x)
        show(io, sv)

        # LArray with Int64
        xi = @LArray [1, 2, 3] (:a, :b, :c)
        _ = xi.a
        yi = @LArray [4, 5, 6] (:a, :b, :c)
        _ = xi .+ yi

        # 2D LArray
        x2d = @LArray Float64 (2, 2) (:a, :b, :c, :d)
        x2d .= [1.0 3.0; 2.0 4.0]
        _ = x2d.a
        _ = x2d.d
    end
end

for LArrayType in [LArray, SLArray]
    @eval function RecursiveArrayTools.DiffEqArray(
            vec::AbstractVector{<:$LArrayType},
            ts::AbstractVector,
            p = nothing
        )
        return RecursiveArrayTools.DiffEqArray(vec, ts, p; variables = collect(symbols(vec[1])))
    end

    @eval function RecursiveArrayTools.DiffEqArray(
            vec::AbstractVector{<:$LArrayType},
            ts::AbstractVector,
            p::NTuple{N, Int}
        ) where {N}
        return invoke(
            RecursiveArrayTools.DiffEqArray,
            Tuple{AbstractVector, AbstractVector, Any},
            vec,
            ts,
            p;
            variables = collect(symbols(vec[1])),
        )
    end
end

using LabelledArrays, OrdinaryDiffEq, Test

LorenzVector = @SLArray (3,) (:x, :y, :z)
LorenzParameterVector = @SLArray (3,) (:σ, :ρ, :β)

function f(u, p, t)
    x = p.σ * (u.y - u.x)
    y = u.x * (p.ρ - u.z) - u.y
    z = u.x * u.y - p.β * u.z
    return LorenzVector(x, y, z)
end

u0 = LorenzVector(1.0, 0.0, 0.0)
p = LorenzParameterVector(10.0, 28.0, 8 / 3)
tspan = (0.0, 10.0)
prob = ODEProblem(f, u0, tspan, p)
sol = solve(prob, Rosenbrock23())
@test sol.retcode == SciMLBase.ReturnCode.Success
sol = solve(prob, Tsit5())
@test prob.u0 === sol.u[1] === u0
@test prob.p === p
@test sol[:, 10].x > 0

function iip_f(du, u, p, t)
    du.x = p.σ * (u.y - u.x)
    du.y = u.x * (p.ρ - u.z) - u.y
    return du.z = u.x * u.y - p.β * u.z
end

u0 = @LArray [1.0, 0.0, 0.0] (:x, :y, :z)
p = LorenzParameterVector(10.0, 28.0, 8 / 3)
tspan = (0.0, 10.0)
prob = ODEProblem(iip_f, u0, tspan, p)

@test similar(u0) isa LArray
@test zero(u0) isa LArray

sol = solve(prob, Rosenbrock23())
sol = solve(prob, Tsit5())
@test typeof(prob.u0) == eltype(sol.u) == typeof(u0)
@test prob.p === p
@test sol[:, 10].x > 0

using ChainRulesCore: ChainRulesCore

unwrap_maybe(x) = x
unwrap_maybe(x::SLArray) = x.__x
unwrap_maybe(x::LArray) = x.__x
# Respect the thunk.
function unwrap_maybe(x::ChainRulesCore.Thunk)
    return ChainRulesCore.@thunk(unwrap_maybe(ChainRulesCore.unthunk(x)))
end

function ChainRulesCore.rrule(::typeof(getproperty), A::Union{SLArray, LArray}, s::Symbol)
    function getproperty_LArray_adjoint(d)
        # Hopefully this reference to `A` is optimized away.
        Δ = similar(A) .= 0
        setproperty!(Δ, s, ChainRulesCore.unthunk(d))
        return (ChainRulesCore.NoTangent(), Δ, ChainRulesCore.NoTangent())
    end
    return getproperty(A, s), getproperty_LArray_adjoint
end

function ChainRulesCore.rrule(::Type{LArray{S}}, x::AbstractArray) where {S}
    # This rule covers constructors of the form `LArray{(:a, :b)}(x)`
    # which, amongst other places, is also used in the `@LArray` macro.
    LArray_adjoint(Δ) = ChainRulesCore.NoTangent(), unwrap_maybe(Δ)
    return LArray{S}(x), LArray_adjoint
end

function ChainRulesCore.rrule(::Type{SLArray{Size, S}}, x::AbstractArray) where {Size, S}
    # This rule covers constructors of the form `SLArray{(2, ), (:a, :b)}(x)`
    # which, amongst other places, is also used in the `@LArray` macro.
    SLArray_adjoint(Δ) = ChainRulesCore.NoTangent(), unwrap_maybe(Δ)
    return SLArray{Size, S}(x), SLArray_adjoint
end

using LabelledArrays
using Test
using StaticArrays
using InteractiveUtils
using ChainRulesTestUtils

const GROUP = get(ENV, "GROUP", "All")

if GROUP == "All"
    @time begin
        @time @testset "SLArrays" begin
            include("slarrays.jl")
        end
        @time @testset "LArrays" begin
            include("larrays.jl")
        end
        @time @testset "DiffEq" begin
            include("diffeq.jl")
        end
        @time @testset "ChainRules" begin
            include("chainrules.jl")
        end
    end
end

if GROUP == "All" || GROUP == "RecursiveArrayTools"
    @time @testset "RecursiveArrayTools" begin
        include("recursivearraytools.jl")
    end
end

if GROUP == "nopre"
    using AllocCheck
    @time @testset "AllocCheck" begin
        include("alloc_tests.jl")
    end
end

# Example: Nice DiffEq Syntax Without A DSL

Users of the SciML ecosystem are often solving large models with complicated
states and hundreds or thousands of parameters. These models are implemented
using arrays, and those arrays have traditionally been indexed by integers,
such as `p[1]` or `p[1:5]`. Numerical indexing is wonderful for small
models, but can quickly cause problems as models become bigger. It is easy to
forget which index corresponds to which reaction rate or which diffusion coefficient.
This confusion can lead to difficult to debug problems in a user's code. `LabelledArrays`
can make an important difference here. It is much easier to build a model using parameter
references such as `p.rate_nacl` or `p.probability_birth`, instead
of `p[26]` or `p[1026]`. Labelled arrays make both the development and debugging of models
much faster.

LabelledArrays.jl are a way to get DSL-like syntax without a macro. In this case,
we can solve differential equations with labelled components by making use of
labelled arrays, and always refer to the components by name instead of index.

One key caveat is that users do not need to sacrifice performance when using
labelled arrays. Labelled arrays are as performant as traditional numerically
indexed arrays.

Let's solve the Lorenz equation using an `LVector`s. `LVectors` are
mutable. Hence, we can use the non-allocating form of the `OrdinaryDiffEq`
API.

```julia
using LabelledArrays, OrdinaryDiffEq

function lorenz_f!(du, u, p, t)
    du.x = p.σ * (u.y - u.x)
    du.y = u.x * (p.ρ - u.z) - u.y
    du.z = u.x * u.y - p.β * u.z
end

u0 = @LArray [1.0, 0.0, 0.0] (:x, :y, :z)
p = @LArray [10.0, 28.0, 8 / 3] (:σ, :ρ, :β)
tspan = (0.0, 10.0)
prob = ODEProblem(lorenz_f!, u0, tspan, p)
sol = solve(prob, Tsit5())
# Now the solution can be indexed as .x/y/z as well!
sol[10].x
```

In the example above, we used an `LArray` to define the
initial state `u0` as well as the parameter vector `p`.
The remainder of the ODE solution steps are no different
that the original `DifferentialEquations` [tutorials](https://docs.sciml.ai/DiffEqDocs/stable/tutorials/ode_example/#Example-2:-Solving-Systems-of-Equations).

Alternatively, we can use an immutable `SLVector` to
implement the same equation. In this case, we need to
use the allocating form of the `OrdinaryDiffEq` API when
defining our model equation.

```julia
LorenzVector = @SLVector (:x, :y, :z)
LorenzParameterVector = @SLVector (:σ, :ρ, :β)

function f(u, p, t)
    x = p.σ * (u.y - u.x)
    y = u.x * (p.ρ - u.z) - u.y
    z = u.x * u.y - p.β * u.z
    LorenzVector(x, y, z)
end

u0 = LorenzVector(1.0, 0.0, 0.0)
p = LorenzParameterVector(10.0, 28.0, 8 / 3)
tspan = (0.0, 10.0)
prob = ODEProblem(f, u0, tspan, p)
sol = solve(prob, Tsit5())
```

# Note: Labelled slices

This functionality has been removed from LabelledArrays.jl, but can
be replicated with the same compile-time performance and indexing syntax
using [DimensionalData.jl](https://github.com/rafaqz/DimensionalData.jl).

# SLArrays

The `SLArray` and `SLVector` macros create static LabelledArrays.
First, the user would create the array type, then use that constructor to generate
instances of the labelled array.

## `@SLArray` and `@SLVector` macros

Macro constructors are convenient for building most `SLArray` objects. An
`@SLArray` may be of arbitrary dimension, while an `@SLVector` is a
one dimensional array.

```@docs
@SLArray
@SLVector
```

## `SLArray` and `SLVector` constructors

Alternatively, users can construct a static labelled array using the
`SLVector` and `SLArrays` constructors by writing out the entries as keyword arguments:

```@docs
SLArray
SLVector
```

## Manipulating `SLArrays` and `SLVectors`

Users may want a list of the labels or keys in an `SLArray` or `SLVector`.
The `symbols(::SLArray)` function returns a tuple of array labels.

```@docs
symbols(::SLArray)
```

# Relation to NamedTuples

Julia's Base has NamedTuples in v0.7+. They are constructed as:

```julia
p = (σ = 10.0, ρ = 28.0, β = 8 / 3)
```

and they support `p[1]` and `p.σ` as well. The `LVector`, `SLVector`, `LArray`
and `SLArray` constructors also support named tuples as their arguments:

```julia
julia> LVector((a = 1, b = 2))
2-element LArray{Int64,1,(:a, :b)}:
 1
 2

julia> SLVector((a = 1, b = 2))
2-element SLArray{Tuple{2},1,(:a, :b),Int64}:
 1
 2

julia> LArray((2, 2), (a = 1, b = 2, c = 3, d = 4))
2×2 LArray{Int64,2,(:a, :b, :c, :d)}:
 1  3
 2  4

julia> SLArray{Tuple{2, 2}}((a = 1, b = 2, c = 3, d = 4))
2×2 SLArray{Tuple{2,2},2,(:a, :b, :c, :d),Int64}:
 1  3
 2  4
```

Converting to a named tuple from a labelled array x is available
using `convert(NamedTuple, x)`. Furthermore, `pairs(x)`
creates an iterator that is functionally the same as
`pairs(convert(NamedTuple, x))`, yielding `:label => x.label`
for each label of the array.

There are some crucial differences between a labelled array and
a named tuple. Labelled arrays can have any dimensions, while
named tuples are always 1D. A named tuple can have different types
on each element, while an `SLArray` can only have one element
type and furthermore it has the actions of a static vector.
As a result `SLArray` has less element type information, which
improves compilation speed while giving more vector functionality
than a NamedTuple. `LArray` also only has a single element type and,
unlike a named tuple, is mutable.

# LArrays

`LArrays` are fully mutable arrays with labels. There is no performance
loss by using labelled indexing instead of purely numerical indexing.
Using the macro with values and labels generates the labelled array with
the given values:

Users interested in using labelled elements in their arrays should also
consider `ComponentArrays` from the
[ComponentArrays.jl](https://docs.sciml.ai/ComponentArrays/stable/)
library. `ComponentArrays` are well integrated into the SciML ecosystem.

## `@LArray` and `@LVector` macros

Macro constructors are convenient for building most `LArray` objects. An
`@LArray` may be of arbitrary dimension, while an `@LVector` is a
one dimensional array.

```@docs
@LArray
@LVector
```

## `LArray` and `LVector` constructors

The original constructors for `LArray`s and `LVector`s are as
follows:

```@docs
LArray
LVector
```

## Manipulating `LArrays` and `LVectors`

Users may want a list of the labels or keys in an `LArray` or `LVector`.
The `symbols(::LArray)` function returns a tuple of array labels.

```@docs
symbols
```
